
;	PIC12F675	youtube1 

;           _____________
;  VDD 3V =1;            ;8= 0V VSS
;     NO  =2;(GP5)  (GP0);7= LED
;     NO  =3;(GP4)  (GP1);6= LED
;     NO  =4;(GP3)  (GP2);5= IN@@@@@@@@   @@
;           _____________@@@@@@@@@@@     
;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	list      p=12f675	
	#include <p12f675.inc>	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	__CONFIG _CP_OFF & _CPD_OFF & _WDT_OFF & _MCLRE_OFF & _PWRTE_ON & _INTRC_OSC_NOCLKOUT	;4MHz

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	errorlevel  -302	
	radix	dec		

	ORG	000H
	GOTO	INIT 

	CH_CNT		EQU	20H
	TM1		EQU	21H
	TM2		EQU	22H
;			EQU	23H
;			EQU	24H
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

INIT:
	BSF	STATUS,RP0

	MOVLW   B'00001100'
	MOVWF	TRISIO 

	MOVLW   B'10000111' 
	MOVWF	OPTION_REG 
                       		
	MOVLW	B'01010100'
	MOVWF	ANSEL

	BCF	STATUS,RP0

	MOVLW	B'00000111'
	MOVWF	CMCON
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

AAA
	BSF	GPIO,0
	BCF	GPIO,1

	CALL	AD_MAIN	
	CALL	TIME

	BCF	GPIO,0
	BSF	GPIO,1

	CALL	AD_MAIN	
	CALL	TIME

	GOTO	AAA

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TIME
	MOVLW	D'60'		;SPEED
	MOVWF	TM1
TIME_1
	MOVLW	D'250'
	MOVWF	TM2
TIME_2
	NOP
	DECFSZ	TM2,F
	GOTO	TIME_2
	
	DECFSZ	TM1,F
	GOTO	TIME_1

	RETURN		

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

AD_MAIN	
	MOVLW	B'00001001'   			
	MOVWF	ADCON0				

	CALL	LOSETIME
	CALL	LOSETIME

AD_MAIN0
	BSF	ADCON0,GO			

AD_MAIN1
	BTFSC	ADCON0,GO
	GOTO	AD_MAIN1			
	GOTO	AD_MAIN2			

AD_MAIN2

	MOVF	ADRESH,W			
	MOVWF	CH_CNT			  	

	RRF	CH_CNT,F			
	RRF	CH_CNT,F			
	RRF	CH_CNT,F			
	RRF	CH_CNT,F			

	MOVF	CH_CNT,W	
	ANDLW	B'00001111'	;0`15
	ADDWF	PCL,F

	RETURN
	RETURN
	RETURN
	RETURN
	RETURN
	RETURN			;MOVE
	GOTO	AD_MAIN		;STOP	
	GOTO	AD_MAIN
	GOTO	AD_MAIN
	GOTO	AD_MAIN
	GOTO	AD_MAIN
	GOTO	AD_MAIN
	GOTO	AD_MAIN
	GOTO	AD_MAIN
	GOTO	AD_MAIN
	GOTO	AD_MAIN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

LOSETIME
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	 
	END

